%global debug_package %{nil}

%define rpm_name		%{name}-%{version}
%define rpm_build_dir_name	${RPM_BUILD_DIR}/%{rpm_name}
%define opt_cpuras		/opt/FJSVxos/cpuras

%define krn_ver			%{xos_krn_ver}

%define tmp_modules_list	/var/run/rpm-kmod-%{name}-modules

%define krequires %(echo %{xos_krn_ver} | sed "s/.%{_target_cpu}$//")
%define ktag %(echo %{krequires} | tr '-' '_' | sed -e 's/\.el[0-9]*$//' | sed -e 's/\.\([a-zA-Z]\)/_\1/')

Name:FJSVxoscpuras
Version:%{pkg_version}
Release:%{pkg_revision}_%{ktag}%{?dist}
Summary:cpu-mem-ras driver
Group:System Environment/Kernel
License:GPLv2
#URL:
#Sourceタグが定義されていないとsrpmが作れない
Source:%{name}-%{version}.tar.gz 

#BuildRoot:     %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
%if "%{?xos_cross_compile}" == ""
BuildRequires:kernel-devel
%endif
#Requires: FJSVxosbmc FJSVxoskdump
#Requires: FJSVxosbmc FJSVxosrdump
#Patch01:hoge.patch

%description
This package provides cpu-mem-ras driver relevant drivers.
Version coexistence: possible
  Previous version: 0.0.6-1.el8 and over
  Same version range: node
After updating: reboot
Relation package: none

%prep
rm -rf %{rpm_build_dir_name}
rm -rf ${RPM_BUILD_ROOT}

%setup

%build
#driver module compile
#now, current dir is %{name}-%{version}
#cpu-mem-ras module compilea
pushd src
ARCH=arm64 CROSS_COMPILE=%{?xos_cross_compile} KDIR=%{xos_krn_dir} make
popd

%install
rm -rf ${RPM_BUILD_ROOT}

#cpu-mem-ras driver install
mkdir -p ${RPM_BUILD_ROOT}/lib/modules/%{krn_ver}/extra/cpuras
install -p -m 644 %{rpm_build_dir_name}/src/cpu_mem_ras.ko ${RPM_BUILD_ROOT}/lib/modules/%{krn_ver}/extra/cpuras

#startup install
mkdir -p ${RPM_BUILD_ROOT}/%{opt_cpuras}/etc
install -p -m 755 %{rpm_build_dir_name}/script/FJSVxoscpuras ${RPM_BUILD_ROOT}/%{opt_cpuras}/etc

#service install
mkdir -p ${RPM_BUILD_ROOT}/etc/systemd/system
install -p -m 644 %{rpm_build_dir_name}/script/FJSVxoscpuras.service ${RPM_BUILD_ROOT}/etc/systemd/system

#fmaras install
mkdir -p ${RPM_BUILD_ROOT}/etc/cron.daily
install -p -m 500 %{rpm_build_dir_name}/fmaras/etc/cron.daily/fmacheck_acore.sh ${RPM_BUILD_ROOT}/etc/cron.daily

# prealloc
mkdir -p ${RPM_BUILD_ROOT}/etc/opt/FJSVtcs/prm/syshook/os/cpuras
install -p -m 500 %{rpm_build_dir_name}/fmaras/etc/opt/FJSVtcs/prm/syshook/os/cpuras/prealloc ${RPM_BUILD_ROOT}/etc/opt/FJSVtcs/prm/syshook/os/cpuras

# postfree
install -p -m 500 %{rpm_build_dir_name}/fmaras/etc/opt/FJSVtcs/prm/syshook/os/cpuras/postfree ${RPM_BUILD_ROOT}/etc/opt/FJSVtcs/prm/syshook/os/cpuras

# syshook.conf
install -p -m 600 %{rpm_build_dir_name}/fmaras/etc/opt/FJSVtcs/prm/syshook/os/cpuras/syshook.conf ${RPM_BUILD_ROOT}/etc/opt/FJSVtcs/prm/syshook/os/cpuras

# fma
mkdir -p ${RPM_BUILD_ROOT}/%{opt_cpuras}/sbin
install -p -m 500 %{rpm_build_dir_name}/fmaras/opt/FJSVxos/cpuras/sbin/fma.v181130 ${RPM_BUILD_ROOT}/%{opt_cpuras}/sbin

%clean
rm -rf %{buildroot}

%pre
if [ "$1" = "2" ]
then
	#perform when upgrade(rpm -U).
	systemctl disable FJSVxoscpuras
fi

%post
if [ -e "/boot/System.map-%{krn_ver}" ]
then
	depmod -aeF "/boot/System.map-%{krn_ver}" "%{krn_ver}" > /dev/null || :
fi

if [ -x "/sbin/weak-modules" ]
then
	rpm -ql %{name}-%{version} | grep '\.ko$' | /sbin/weak-modules --add-modules --no-initramfs
fi
systemctl enable FJSVxoscpuras

%preun
if [ "$1" = "0" ]
then
	#perform when elase(rpm -e) only.
	systemctl disable FJSVxoscpuras
fi

rpm -ql %{name}-%{version} | grep '\.ko$' > %{tmp_modules_list}

%postun
if [ -e "/boot/System.map-%{krn_ver}" ]
then
	depmod -aeF "/boot/System.map-%{krn_ver}" "%{krn_ver}" > /dev/null || :
fi

modules=( $(cat %{tmp_modules_list}) )
rm %{tmp_modules_list}
if [ -x "/sbin/weak-modules" ]
then
	printf '%s\n' "${modules[@]}" | /sbin/weak-modules --remove-modules --no-initramfs
fi

%files

%defattr(644,root,root,-)
/etc/systemd/system/FJSVxoscpuras.service
/lib/modules/%{krn_ver}/extra/cpuras/cpu_mem_ras.ko

%defattr(755,root,root,-)
%{opt_cpuras}/etc/FJSVxoscpuras

%defattr(500,root,root,-)
/etc/cron.daily/fmacheck_acore.sh
/etc/opt/FJSVtcs/prm/syshook/os/cpuras/prealloc
/etc/opt/FJSVtcs/prm/syshook/os/cpuras/postfree
%{opt_cpuras}/sbin/fma.v181130

%defattr(600,root,root,-)
/etc/opt/FJSVtcs/prm/syshook/os/cpuras/syshook.conf

%changelog

